<?php

namespace Insign\PostCore\Plugin;

use Magento\Checkout\Api\Data\ShippingInformationInterface;
use Magento\Checkout\Model\Session;
use Magento\Checkout\Model\ShippingInformationManagement;

class SaveValidStatus
{
    /**
     * @var Session
     */
    private $checkoutSession;

    /**
     * SaveValidStatus constructor.
     * @param Session $checkoutSession
     */
    public function __construct(Session $checkoutSession)
    {
        $this->checkoutSession = $checkoutSession;
    }

    /**
     * @param ShippingInformationManagement $subject
     * @param $cartId
     * @param ShippingInformationInterface $addressInformation
     * @return ShippingInformationManagement
     */
    public function beforeSaveAddressInformation(
        ShippingInformationManagement $subject,
        $cartId,
        ShippingInformationInterface $addressInformation
    )
    {
        $validationStatus = $this->checkoutSession->getVarValue();
        $shippingAddress = $addressInformation->getShippingAddress();
        $shippingAddress->setAddressValidationStatus($validationStatus);
        $this->checkoutSession->unsVarValue();
    }
}
